package org.jeecg.modules.energy.controller;

import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;
import java.util.Map;
import java.util.stream.Collectors;
import java.io.IOException;
import java.io.UnsupportedEncodingException;
import java.net.URLDecoder;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import org.apache.commons.lang.StringUtils;
import org.jeecg.common.api.vo.Result;
import org.jeecg.common.system.query.QueryGenerator;
import org.jeecg.common.util.oConvertUtils;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import lombok.extern.slf4j.Slf4j;

import org.jeecg.config.mybatis.ThreadLocalDataHelper;
import org.jeecg.modules.device.entity.BuDevice;
import org.jeecg.modules.device.service.IBuDeviceService;
import org.jeecg.modules.energy.entity.BuAirNoise;
import org.jeecg.modules.energy.entity.BuAirSmoke;
import org.jeecg.modules.energy.service.IBuAirNoiseService;
import org.jeecg.modules.sensor.entity.BuSensor;
import org.jeecg.modules.sensor.entity.BuSensorType;
import org.jeecg.modules.sensor.service.IBuSensorService;
import org.jeecg.modules.sensor.service.IBuSensorTypeService;
import org.jeecgframework.poi.excel.ExcelImportUtil;
import org.jeecgframework.poi.excel.def.NormalExcelConstants;
import org.jeecgframework.poi.excel.entity.ExportParams;
import org.jeecgframework.poi.excel.entity.ImportParams;
import org.jeecgframework.poi.excel.view.JeecgEntityExcelView;
import org.jeecg.common.system.base.controller.JeecgController;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.multipart.MultipartFile;
import org.springframework.web.multipart.MultipartHttpServletRequest;
import org.springframework.web.servlet.ModelAndView;
import com.alibaba.fastjson.JSON;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.jeecg.common.aspect.annotation.AutoLog;

 /**
 * @Description: bu_air_noise_online
 * @Author: jeecg-boot
 * @Date:   2024-10-11
 * @Version: V1.0
 */
@Api(tags="bu_air_noise_online")
@RestController
@RequestMapping("/energy/buAirNoise")
@Slf4j
public class BuAirNoiseController extends JeecgController<BuAirNoise, IBuAirNoiseService> {
	@Autowired
	private IBuAirNoiseService buAirNoiseService;
	@Autowired
	private IBuSensorService buSensorService;
	@Autowired
	private IBuDeviceService buDeviceService;
	@Autowired
	private IBuSensorTypeService buSensorTypeService;
	/**
	 * 分页列表查询
	 *
	 * @param buAirNoise
	 * @param pageNo
	 * @param pageSize
	 * @param req
	 * @return
	 */
	//@AutoLog(value = "bu_air_noise_online-分页列表查询")
	@ApiOperation(value="bu_air_noise_online-分页列表查询", notes="bu_air_noise_online-分页列表查询")
	@GetMapping(value = "/list")
	public Result<IPage<BuAirNoise>> queryPageList(BuAirNoise buAirNoise,
								   @RequestParam(name="pageNo", defaultValue="1") Integer pageNo,
								   @RequestParam(name="pageSize", defaultValue="10") Integer pageSize,
								   HttpServletRequest req) {
		BuDevice buDevice = buDeviceService.getById(buAirNoise.getDeviceId());
		List<BuSensor> buSensors = buSensorService.getByCheckName(buDevice.getId(),"%噪声%");
		BuSensorType buSensorType = buSensorTypeService.getById(buSensors.get(0).getTypeId());
		String tableName = "";
		if(buAirNoise.getBeginTime()!=null){
			String substring = buAirNoise.getBeginTime().substring(0, buAirNoise.getBeginTime()
					.indexOf("-", buAirNoise.getBeginTime().indexOf("-") + 1)).replaceAll("-","");
//			tableName = buSensorType.getTableHead() + "_history_" + buDevice.getTypeId() + "_" + buDevice.getDeviceCode() + "_" + substring;
			tableName = buSensorType.getTableHead() + "_history_" + substring;
		}
		ThreadLocalDataHelper.put("bu_noise_online",tableName);
//		QueryWrapper<BuAirSmoke> queryWrapper = QueryGenerator.initQueryWrapper(buAirSmoke, req.getParameterMap());
		LambdaQueryWrapper<BuAirNoise> queryWrapper = new LambdaQueryWrapper<>();
		if(buAirNoise.getDeviceId()!=null){
			LambdaQueryWrapper<BuSensor> lambdaQueryWrapper = new LambdaQueryWrapper<>();
			lambdaQueryWrapper.eq(BuSensor::getDeviceId,buAirNoise.getDeviceId());
			List<String> codeList = buSensorService.list(lambdaQueryWrapper).stream().map(BuSensor::getId).collect(Collectors.toList());
			queryWrapper.in(BuAirNoise::getSensorId,codeList);
		}
		if(buAirNoise.getSensorId()!=null){
			queryWrapper.eq(BuAirNoise::getSensorId,buAirNoise.getSensorId());
		}
		if (StringUtils.isNotBlank(buAirNoise.getBeginTime()) && StringUtils.isNotBlank(buAirNoise.getEndTime())){
			queryWrapper.between(BuAirNoise::getCreateTime,buAirNoise.getBeginTime(),buAirNoise.getEndTime());
		}
		if (StringUtils.isNotBlank(buAirNoise.getInTime()) && StringUtils.isNotBlank(buAirNoise.getOutTime())){
			queryWrapper.between(BuAirNoise::getCreateTime,buAirNoise.getInTime(),buAirNoise.getOutTime());
		}
		queryWrapper.orderByDesc(BuAirNoise::getCreateTime);
		Page<BuAirNoise> page = new Page<BuAirNoise>(pageNo, pageSize);
		page.setOptimizeCountSql(false);
		IPage<BuAirNoise> pageList = buAirNoiseService.page(page, queryWrapper);
		return Result.OK(pageList);
	}


	@AutoLog(value = "噪声传感器数据-首页查询")
	@ApiOperation(value="噪声传感器数据-首页查询", notes="噪声传感器数据-首页查询")
	@GetMapping(value = "/getAirNoiseData")
	public Result<?> getAirSmokeData() {
		List<BuAirNoise> buAirNoiseList = buAirNoiseService.getAirNoiseData();
		List<List<String>> lists = new ArrayList<>();
		SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");
		for (BuAirNoise buAirNoise : buAirNoiseList) {
			buAirNoise.setDeviceName(buAirNoise.getDeviceName()+buAirNoise.getDeviceCode());
		}
		return Result.OK(buAirNoiseList);
	}

	/**
	 *   添加
	 *
	 * @param buAirNoise
	 * @return
	 */
	@AutoLog(value = "bu_air_noise_online-添加")
	@ApiOperation(value="bu_air_noise_online-添加", notes="bu_air_noise_online-添加")
	//@RequiresPermissions("org.jeecg.modules.demo:bu_air_noise_online:add")
	@PostMapping(value = "/add")
	public Result<String> add(@RequestBody BuAirNoise buAirNoise) {
		buAirNoiseService.save(buAirNoise);
		return Result.OK("添加成功！");
	}
	
	/**
	 *  编辑
	 *
	 * @param buAirNoise
	 * @return
	 */
	@AutoLog(value = "bu_air_noise_online-编辑")
	@ApiOperation(value="bu_air_noise_online-编辑", notes="bu_air_noise_online-编辑")
	//@RequiresPermissions("org.jeecg.modules.demo:bu_air_noise_online:edit")
	@RequestMapping(value = "/edit", method = {RequestMethod.PUT,RequestMethod.POST})
	public Result<String> edit(@RequestBody BuAirNoise buAirNoise) {
		buAirNoiseService.updateById(buAirNoise);
		return Result.OK("编辑成功!");
	}
	
	/**
	 *   通过id删除
	 *
	 * @param id
	 * @return
	 */
	@AutoLog(value = "bu_air_noise_online-通过id删除")
	@ApiOperation(value="bu_air_noise_online-通过id删除", notes="bu_air_noise_online-通过id删除")
	//@RequiresPermissions("org.jeecg.modules.demo:bu_air_noise_online:delete")
	@DeleteMapping(value = "/delete")
	public Result<String> delete(@RequestParam(name="id",required=true) String id) {
		buAirNoiseService.removeById(id);
		return Result.OK("删除成功!");
	}
	
	/**
	 *  批量删除
	 *
	 * @param ids
	 * @return
	 */
	@AutoLog(value = "bu_air_noise_online-批量删除")
	@ApiOperation(value="bu_air_noise_online-批量删除", notes="bu_air_noise_online-批量删除")
	//@RequiresPermissions("org.jeecg.modules.demo:bu_air_noise_online:deleteBatch")
	@DeleteMapping(value = "/deleteBatch")
	public Result<String> deleteBatch(@RequestParam(name="ids",required=true) String ids) {
		this.buAirNoiseService.removeByIds(Arrays.asList(ids.split(",")));
		return Result.OK("批量删除成功!");
	}
	
	/**
	 * 通过id查询
	 *
	 * @param id
	 * @return
	 */
	//@AutoLog(value = "bu_air_noise_online-通过id查询")
	@ApiOperation(value="bu_air_noise_online-通过id查询", notes="bu_air_noise_online-通过id查询")
	@GetMapping(value = "/queryById")
	public Result<BuAirNoise> queryById(@RequestParam(name="id",required=true) String id) {
		BuAirNoise buAirNoise = buAirNoiseService.getById(id);
		if(buAirNoise==null) {
			return Result.error("未找到对应数据");
		}
		return Result.OK(buAirNoise);
	}

    /**
    * 导出excel
    *
    * @param request
    * @param buAirNoise
    */
    //@RequiresPermissions("org.jeecg.modules.demo:bu_air_noise_online:exportXls")
    @RequestMapping(value = "/exportXls")
    public ModelAndView exportXls(HttpServletRequest request, BuAirNoise buAirNoise) {
        return super.exportXls(request, buAirNoise, BuAirNoise.class, "bu_air_noise_online");
    }

    /**
      * 通过excel导入数据
    *
    * @param request
    * @param response
    * @return
    */
    //@RequiresPermissions("bu_air_noise_online:importExcel")
    @RequestMapping(value = "/importExcel", method = RequestMethod.POST)
    public Result<?> importExcel(HttpServletRequest request, HttpServletResponse response) {
        return super.importExcel(request, response, BuAirNoise.class);
    }

}
